#!/usr/bin/env python
# -*- coding: utf8 -*-
import os
import re
import sys

def convert_charset(n,charset):
	if not n: return
	f = open(n,'r')
	lines = f.readlines()
	f.close()

	lines2 = []
	d = False
	for line in lines:
		if re.search('CHARSET_SHIFT_JIS',line):
			d = True
		lines2.append( re.sub('CHARSET_SHIFT_JIS',charset,line) )
	if d:
		print n
		f = open(n,'w')
		f.writelines(lines2)
		f.close()

def convert_charset_utf8(n):
	convert_charset(n,'CHARSET_UTF_8')

def convert_charset_euc_jp(n):
	convert_charset(n,'CHARSET_EUC_JP')

def convert(n):
	if not n: return
	f = open(n,'r')
	data = f.read()
	f.close()
	d = False
	a = ''
	for c in data:
		if ord(c) >= 0x80:
			d = True
			a += u'\\x%0X' % (ord(c))
		else:
			a += c
	if d:
		print n
		f = open(n,'w')
		f.write(a.encode('sjis'))
		f.close()

def rec_exec(func,filter,path):
	if not func: return
	for name in os.listdir(path):
		full = os.path.join(path,name)
		if os.path.isfile(full):
			if re.search(filter,name):
				func(full)
		elif os.path.isdir(full):
			rec_exec(func,filter,full)

def main():
	argvs = sys.argv
	charset = 'CHARSET_SHIFT_JIS'
	if len(argvs) >= 2:
		tmp = argvs[1].upper()
		if tmp == 'UTF-8':
			charset = 'CHARSET_UTF_8'
		elif tmp == 'UTF_8':
			charset = 'CHARSET_UTF_8'
		elif tmp == 'UTF8':
			charset = 'CHARSET_UTF_8'
		elif tmp == 'EUC':
			charset = 'CHARSET_EUC_JP'
		elif tmp == 'EUC_JP':
			charset = 'CHARSET_EUC_JP'
		elif tmp == 'EUC-JP':
			charset = 'CHARSET_EUC_JP'
		elif tmp == 'SHIFT_JIS':
			charset = 'CHARSET_SHIFT_JIS'
		elif tmp == 'SJIS':
			charset = 'CHARSET_SHIFT_JIS'
		elif tmp == 'SHIFT-JIS':
			charset = 'CHARSET_SHIFT_JIS'
		elif tmp == 'SHIFTJIS':
			charset = 'CHARSET_SHIFT_JIS'
		else:
			raise Exception( u'未対応の文字セットです。'.encode( 'sjis' ) )

	if charset == 'CHARSET_EUC_JP':
		rec_exec(convert,'euc_jp\.h$','.')
		rec_exec(convert_charset_euc_jp,'\.vcproj$','.')
	elif charset == 'CHARSET_UTF_8':
		rec_exec(convert,'utf_8\.h$', '.')
		rec_exec(convert_charset_utf8,'\.vcproj$','.')

if __name__ == '__main__':
	main()
